/////////////////////////////////////////////////////////////////////////////
//		CSetup.cpp
#include	<windows.h>
#include	<shlobj.h>
#include	"util.h"
#include	"ShInf.h"


/////////////////////////////////////////////////////////
//	쐬Ej

//RXgN^
CSetup::CSetup( REFCLSID rclsid )
{
#ifdef _UNICODE
	StringFromGUID2( rclsid, m_szCLSID, 40 );
#else
	WCHAR	wszCLSID[40];

	StringFromGUID2( rclsid, wszCLSID, 40 );
	WideCharToMultiByte( CP_ACP, 0, wszCLSID, -1, m_szCLSID, 40, NULL, NULL );
#endif
}

//fXgN^
CSetup::~CSetup( void )
{
}


/////////////////////////////////////////////////////////
//	֐

//CXg[
BOOL CSetup::RegCLSID( LPTSTR szApp, LPTSTR szFile )
{
	TCHAR	szTmp[MAX_PATH];
	HKEY	hKey1, hKey2;
	BOOL	Result = FALSE;

	wsprintf( szTmp, _T("CLSID\\%s"), m_szCLSID );
	hKey1 = RegKeyCreate( HKEY_CLASSES_ROOT, szTmp );
	if( hKey1 )
	{
		RegSetString( hKey1, NULL, szApp );
		hKey2 = RegKeyCreate( hKey1, _T("InProcServer32") );
		if( hKey2 )
		{
			RegSetString( hKey2, NULL, szFile );
			RegSetString( hKey2, _T("ThreadingModel"), _T("Apartment") );
			RegKeyClose( hKey2 );

			Result = TRUE;
		}
		RegKeyClose( hKey1 );
	}

	return	Result;
}

BOOL CSetup::RegShellEx( LPTSTR szExt, LPTSTR szShellEx, LPTSTR szApp )
{
	TCHAR	szTmp[MAX_PATH];
	HKEY	hKey;
	BOOL	Result = FALSE;

	wsprintf( szTmp, _T("%s\\shellex\\%s\\%s"), szExt, szShellEx, szApp );
	hKey = RegKeyCreate( HKEY_CLASSES_ROOT, szTmp );
	if( hKey )
	{
		RegSetString( hKey, NULL, m_szCLSID );
		RegKeyClose( hKey );

		Result = TRUE;
	}

	return	Result;
}


//ACXg[
BOOL CSetup::UnregCLSID( void )
{
	TCHAR	szKey[MAX_PATH];

	wsprintf( szKey, _T("CLSID\\%s\\InProcServer32"), m_szCLSID );
	return	RegKeyForceDelete( HKEY_CLASSES_ROOT, szKey );
}

BOOL CSetup::UnregShellEx( LPTSTR szExt, LPTSTR szShellEx, LPTSTR szApp )
{
	TCHAR	szKey[MAX_PATH];

	wsprintf( szKey, _T("%s\\shellex\\%s\\%s"), szExt, szShellEx, szApp );
	return	RegKeyForceDelete( HKEY_CLASSES_ROOT, szKey );
}
