/////////////////////////////////////////////////////////////////////////////
//		ShInf.h


/////////////////////////////////////////////////////////
//	W[̓o^E폜

class CSetup
{
private:
	TCHAR		m_szCLSID[40];

public:
	CSetup( REFCLSID );
	~CSetup( void );

	BOOL		RegCLSID( LPTSTR, LPTSTR );
	BOOL		RegShellEx( LPTSTR, LPTSTR, LPTSTR );
	BOOL		UnregCLSID( void );
	BOOL		UnregShellEx( LPTSTR, LPTSTR, LPTSTR );
};


/////////////////////////////////////////////////////////
//	y[W

//y[W
class CPage
{
public:
	virtual	BOOL			CheckFile( LPCTSTR )					= NULL;
	virtual	LPCTSTR			GetDlgTitle()						= NULL;
	virtual	LPCTSTR			GetDlgTemplate()					= NULL;
	virtual	BOOL			OnInitDialog( HWND, HWND, LPARAM )	= NULL;
	virtual	BOOL			OnDestory( HWND )					= NULL;
	virtual	BOOL			OnNofity( HWND, int, LPNMHDR )		= NULL;
	virtual	BOOL			OnCommand( HWND, int, HWND, UINT )	= NULL;
};

//swb_
class CPageExe : public CPage
{
private:
	IMAGE_DOS_HEADER		m_doshdr;
	IMAGE_NT_HEADERS		m_nthdr;
	WORD					m_sechdr_num;
	IMAGE_SECTION_HEADER*	m_sechdr_ary;
	LPSTR					m_impsec;
	DWORD					m_impsec_addr;
	LPSTR					m_expsec;
	DWORD					m_expsec_addr;

public:
	CPageExe();
	~CPageExe();

	virtual	BOOL			CheckFile( LPCTSTR );
	virtual	LPCTSTR			GetDlgTitle();
	virtual	LPCTSTR			GetDlgTemplate();
	virtual	BOOL			OnInitDialog( HWND, HWND, LPARAM );
	virtual	BOOL			OnDestory( HWND );
	virtual	BOOL			OnNofity( HWND, int, LPNMHDR );
	virtual	BOOL			OnCommand( HWND, int, HWND, UINT );

private:
			BOOL			OnInitDOS( HWND );
			BOOL			OnInitPE( HWND );
			BOOL			OnInitSection( HWND );
			BOOL			OnInitDirectory( HWND );
			BOOL			OnInitImport( HWND );
			BOOL			OnInitExport( HWND );
};


/////////////////////////////////////////////////////////
//	IUnknown̐錾

//֐
BOOL IsDllUnlocked();

//NXIuWFNg̊Ǘ
class CClassFactory : public IClassFactory
{
private:
	ULONG		m_cRef;						//DLL̎QƉ

public:
	CClassFactory();
	~CClassFactory();

	//IUnknown
	STDMETHODIMP			QueryInterface( REFIID, LPVOID* );
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();

	//IClassFactory
	STDMETHODIMP			CreateInstance( LPUNKNOWN, REFIID, LPVOID* );
	STDMETHODIMP			LockServer( BOOL );
};

//VFg
class CShellExtension : public IShellExtInit, IShellPropSheetExt
{
private:
	ULONG		m_cRef;						//DLL̎QƉ
	TCHAR		m_szFile[MAX_PATH];			//Ώۃt@C

	CPageExe	m_PageExe;

public:
	CShellExtension();
	~CShellExtension();

	//IUnknown
	STDMETHODIMP			QueryInterface( REFIID, LPVOID* );
	STDMETHODIMP_(ULONG)	AddRef();
	STDMETHODIMP_(ULONG)	Release();

	//IShellExtInit
	STDMETHODIMP			Initialize( LPCITEMIDLIST, LPDATAOBJECT, HKEY );

	//IShellPropSheetExt
	STDMETHODIMP			AddPages( LPFNADDPROPSHEETPAGE, LPARAM );
	STDMETHODIMP			ReplacePage( UINT, LPFNADDPROPSHEETPAGE, LPARAM );

private:
			STDMETHODIMP		AddPage( CPage*, LPFNADDPROPSHEETPAGE, LPARAM );
	static	BOOL	CALLBACK	DlgProc( HWND, UINT, WPARAM, LPARAM );
};


/////////////////////////////////////////////////////////
//	֐̐錾

//GNX|[g
STDAPI DllGetClassObject( REFCLSID, REFIID, LPVOID* );
STDAPI DllCanUnloadNow();
STDAPI DllRegisterServer( void );
STDAPI DllUnregisterServer( void );
