/////////////////////////////////////////////////////////////////////////////
//		CUnknown.cpp
#include	<windows.h>
#include	<shlobj.h>
#include	"ShInf.h"


/////////////////////////////////////////////////////////
//	錾

//ϐ
extern	HINSTANCE			g_hInst;			//DLL̃CX^X
		UINT				g_cRefThisDll = 0;	//DLLQƂ
		CShellExtension*	g_pShellExtension;	//CShellExtensioñ|C^


/////////////////////////////////////////////////////////
//	NXIuWFNg̑

//NXIuWFNg̊J
BOOL IsDllUnlocked()
{
	return	( g_cRefThisDll == 0 );
}


/////////////////////////////////////////////////////////
//	NXIuWFNg̊Ǘ

//RXgN^EfXgN^
CClassFactory::CClassFactory()
{
	++g_cRefThisDll;
	m_cRef = 1;
}
CClassFactory::~CClassFactory()
{
	--g_cRefThisDll;
}

//IUnknown

//IuWFNǧJ
STDMETHODIMP CClassFactory::QueryInterface( REFIID riid, LPVOID* ppvObj )
{
	HRESULT	hr;

	if( riid == IID_IUnknown || riid == IID_IClassFactory )	{
		*ppvObj = this;
		hr      = NOERROR;
		++m_cRef;
	}
	else	{
		*ppvObj = NULL;
		hr      = E_NOINTERFACE;
	}

	return	hr;
}

//IuWFNg̎QƁEJ
STDMETHODIMP_(ULONG) CClassFactory::AddRef()
{
	return	++m_cRef;
}
STDMETHODIMP_(ULONG) CClassFactory::Release()
{
	if( --m_cRef == 0 )
		delete this;

	return	m_cRef;
}

//IClassFactory

//w肵CLSID̃IuWFNg쐬
STDMETHODIMP CClassFactory::CreateInstance( LPUNKNOWN pUnkOuter,
									REFIID riid, LPVOID* ppvObj )
{
	HRESULT				hr;
	CShellExtension*	pShellExtension;

	*ppvObj = NULL;
	if( pUnkOuter != NULL )
		return	CLASS_E_NOAGGREGATION;

	pShellExtension = new CShellExtension;
	if( pShellExtension == NULL )
		return	E_OUTOFMEMORY;

	hr = pShellExtension->QueryInterface( riid, ppvObj );
		 pShellExtension->Release();

	return	hr;
}

//NXt@NgbN
STDMETHODIMP CClassFactory::LockServer( BOOL fLock )
{
	return	E_NOTIMPL;
}


/////////////////////////////////////////////////////////
//	VFg

//RXgN^EfXgN^
CShellExtension::CShellExtension()
{
	++g_cRefThisDll;
	m_cRef = 1;
	ZeroMemory( m_szFile, MAX_PATH );
	g_pShellExtension = this;
}
CShellExtension::~CShellExtension()
{
	--g_cRefThisDll;
}

//IUnknown

//IuWFNǧJ
STDMETHODIMP CShellExtension::QueryInterface( REFIID riid, LPVOID* ppvObj )
{
	HRESULT		hr;

	if( riid == IID_IUnknown )	{
		*ppvObj = (LPUNKNOWN)(LPSHELLPROPSHEETEXT)this;
		hr = NOERROR;
		++m_cRef;
	}
	else if( riid == IID_IShellPropSheetExt )	{
		*ppvObj = (LPSHELLPROPSHEETEXT)this;
		hr = NOERROR;
		++m_cRef;
	}
	else if( riid == IID_IShellExtInit )	{
		*ppvObj = (LPSHELLEXTINIT)this;
		hr = NOERROR;
		++m_cRef;
	}
	else	{
		*ppvObj = NULL;
		hr = E_NOINTERFACE;
	}

	return	hr;
}

//IuWFNg̎QƁEJ
STDMETHODIMP_(ULONG) CShellExtension::AddRef()
{
	return	++m_cRef;
}
STDMETHODIMP_(ULONG) CShellExtension::Release()
{
	if( --m_cRef == 0 )
		delete this;

	return	m_cRef;
}

//IShellExtInit

//
STDMETHODIMP CShellExtension::Initialize( LPCITEMIDLIST pidlFolder,
									LPDATAOBJECT lpdobj, HKEY hKeyProgID )
{
	HRESULT		hr;
	STGMEDIUM	medium;
	FORMATETC	fe = { CF_HDROP, NULL, DVASPECT_CONTENT, -1, TYMED_HGLOBAL };

	if( lpdobj == NULL )
		return	E_FAIL;

	hr = lpdobj->GetData( &fe, &medium );
	if( FAILED(hr) )
		return	E_FAIL;

	//Ώۃt@C̎擾
	if( DragQueryFile( (HDROP)medium.hGlobal, (UINT)-1, NULL, 0 ) == 1 )	{
		DragQueryFile( (HDROP)medium.hGlobal, 0, m_szFile, sizeof(m_szFile) );
		hr = S_OK;
	}
	else
		hr = E_FAIL;

	ReleaseStgMedium( &medium );

	return hr;
}

//IShellPropSheetExt

//y[W̒ǉ
STDMETHODIMP CShellExtension::AddPages( LPFNADDPROPSHEETPAGE lpfnAddPage, LPARAM lParam )
{
	HRESULT		hr = S_OK;

	hr = AddPage( &m_PageExe, lpfnAddPage, lParam );

	return	hr;
}

//y[W̒u
STDMETHODIMP CShellExtension::ReplacePage( UINT uPageID, LPFNADDPROPSHEETPAGE lpfnReplacePage, LPARAM lParam )
{
	return	E_FAIL;
}

//Other

//Py[W̒ǉ
STDMETHODIMP CShellExtension::AddPage( CPage* pPage, LPFNADDPROPSHEETPAGE lpfnAddPage, LPARAM lParam )
{
	if( !pPage->CheckFile(m_szFile) )
		return	S_OK;

	PROPSHEETPAGE	psp;
	HPROPSHEETPAGE	hPage;

	ZeroMemory( &psp, sizeof(PROPSHEETPAGE) );
	psp.dwSize		= sizeof(PROPSHEETPAGE);
	psp.dwFlags		= PSP_USEREFPARENT | PSP_USETITLE;
	psp.hInstance	= g_hInst;
	psp.lParam		= (LPARAM)pPage;
	psp.pszTitle	= pPage->GetDlgTitle();
	psp.pszTemplate	= pPage->GetDlgTemplate();
	psp.pfnDlgProc	= (DLGPROC)DlgProc;
    psp.pcRefParent	= &g_cRefThisDll;

	hPage = CreatePropertySheetPage(&psp);
	if( hPage ){
		if( lpfnAddPage(hPage,lParam) )
			g_pShellExtension->AddRef();
		else
			DestroyPropertySheetPage(hPage);
	}

	return	S_OK;
}

//y[W̃vV[W
BOOL CALLBACK CShellExtension::DlgProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	BOOL	Result;
	CPage*	pPage;

	switch( uMsg ){
	case WM_INITDIALOG:
		pPage  = (CPage*)(((PROPSHEETPAGE*)lParam)->lParam);
		SetWindowLong( hWnd, DWL_USER, (DWORD)pPage );
		Result = pPage->OnInitDialog( hWnd, (HWND)wParam, lParam );
		break;
	case WM_DESTROY:
		pPage  = (CPage*)GetWindowLong( hWnd, DWL_USER );
		Result = pPage->OnDestory( hWnd );
		g_pShellExtension->Release();
		break;
	case WM_NOTIFY:
		pPage  = (CPage*)GetWindowLong( hWnd, DWL_USER );
		Result = pPage->OnNofity( hWnd, (int)wParam, (LPNMHDR)lParam );
		break;
	case WM_COMMAND:
		pPage  = (CPage*)GetWindowLong( hWnd, DWL_USER );
		Result = pPage->OnCommand( hWnd, (int)(LOWORD(wParam)), (HWND)(lParam), (UINT)HIWORD(wParam) );
		break;

	default:
		Result = FALSE;
	}

	return( Result );
}
